<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 23/04/2015
 * Time: 13:41
 */

namespace Service\Calendar\Precursor\Strategy;



use Service\TaskPrecursor;
use Util\Utilities;

class EndToStart extends PrecursorStrategyAbstract{



    public function setDates()
    {
    }

    public function getDatesBeginAndEnd($setAllocation = true)
    {
        $task = $this->taskRelationship->getTask();
        $beginTask = $this->getDateBegin();

        $endTask = $this->taskCalendar->getDateEnd($task, clone $beginTask, $setAllocation);
        return array($beginTask,$endTask);
    }
    private function getDateBegin(){

        $taskRelationship = $this->taskRelationship->getTaskRelationship();
        /** @var |ProjectManagement\Entities\Model\Task $task */
        $task = $this->taskRelationship->getTask();
        $beginTask = clone $taskRelationship->getEstimatedEndDate();
        $this->taskCalendar->setPreviousTimeTask($task);
        $previousTime = $task->getPreviousTime();
        $beginTask = $this->taskCalendar->getNextWorkingDayByTask($task,$beginTask,!$previousTime);
        return $beginTask;
    }

    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\Entities\Task $task
     * @param int $duration
     * @return int
     */
    private function getAllDurationsDay($task,$duration = 0)
    {
        $tasksRelationship = $task->getTaskRelationship();
        foreach($tasksRelationship as $taskRelationship){
            if($taskRelationship->getTypePrecursor() == PrecursorFactory::END_TO_START &&
                $taskRelationship->getType() == TaskPrecursor::PRECURSOR_TYPE){
                $taskPrecursor = $taskRelationship->getTaskRelationship();
                $duration += $taskPrecursor->getDuration();
                $duration = $this->getAllDurationsDay($taskPrecursor,$duration);
            }
        }
        return $duration;
    }
}