<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;


class WorkedTime extends \Doctrine\ORM\EntityRepository
{

    public function getWorkTimeByUserAndDate($userId, $dateString)
    {
        $query = <<<SQL
	 		SELECT W.WORK_TIME
	 		  FROM WORKED_TIME W
	 		 WHERE W.RESOURCE_T = :userId
	 		   AND W.WORK_DATE = TO_DATE(:dateString, 'DD/MM/YYYY')
SQL;
        $params = array(
            'userId' => $userId,
            'dateString' => $dateString
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getWorkTimeByUserAndBetweenDates($userId, $betweenDateString)
    {
        $query = <<<SQL
	 		SELECT  W.WORK_TIME ,TO_CHAR(W.WORK_DATE, 'DD/MM/YYYY') AS WORK_DATE, W.IS_PENDING
	 		  FROM  WORKED_TIME W
	 		 WHERE 	W.RESOURCE_T = :userId
	 		   AND 	W.WORK_DATE $betweenDateString
SQL;
        $params = array(
            'userId' => $userId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findWorkedTimeAndTotalAppropriatedByUserAndBetweenDate($userId, $betweenDateString)
    {
        $query = <<<SQL
            SELECT WORK_TIME, WORK_DATE, SUM(APPROPRIATE_TOTAL) AS APPROPRIATE_TOTAL 
              FROM (SELECT W.WORK_TIME ,TO_CHAR(W.WORK_DATE, 'DD/MM/YYYY') AS WORK_DATE, NVL(SUM(A.TOTAL), 0) AS APPROPRIATE_TOTAL 
                      FROM WORKED_TIME W
                 LEFT JOIN APPROPRIATION A ON TO_CHAR(A.BEGIN_HOUR, 'DD/MM/YYYY') = TO_CHAR(W.WORK_DATE, 'DD/MM/YYYY') AND A.RESOURCE_T = :USER_ID
                     WHERE W.RESOURCE_T = :USER_ID
                       AND W.WORK_DATE $betweenDateString
                  GROUP BY W.WORK_TIME, W.WORK_DATE

                     UNION
                 
                    SELECT W.WORK_TIME ,TO_CHAR(W.WORK_DATE, 'DD/MM/YYYY') AS WORK_DATE, round(NVL(SUM(F.QTHORASAPROPRIADAS) * 3600, 0), 0) AS APPROPRIATE_TOTAL 
                      FROM WORKED_TIME W
                 LEFT JOIN OPERADOR      O ON O.CDOPERADOR = W.EXTERNAL_ID
                 LEFT JOIN FCT_APROPAGENDAMENTO F ON TO_CHAR(F.DTAPROPRIACAO, 'DD/MM/YYYY') = TO_CHAR(W.WORK_DATE, 'DD/MM/YYYY') AND F.NRPARCNEGRECURSO = O.NRPARCNEGOCIO
                     WHERE W.RESOURCE_T = :USER_ID
                       AND W.WORK_DATE $betweenDateString
                  GROUP BY W.WORK_TIME, W.WORK_DATE)
          GROUP BY WORK_TIME, WORK_DATE
SQL;
        
        $params = array(
            ':USER_ID' => $userId
        );        
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

}